import snapd;
import commandr;
import std.file;

import core.stdc.stdlib : EXIT_SUCCESS, EXIT_FAILURE;

private string programName = "snapd";

int main(string[] args)
{
	auto argumets = new Program(programName, snapdVersion)
		.add(new Command("init", "Initializing the repository for storing snapshots"))
		.add(new Command("status", "Checking the status of tracked files"))
		.add(new Command("create", "Create a new backup"))
		.add(new Option("c", "config", "Сonfiguration file path")
			.optional
			.validateEachWith(
				opt => opt.exists && opt.isFile,
				"A JSON file path must be provided"
			)
		)
		.parse(args);

	string configFile = argumets.option("config", "snapd.json");

	SnapdConfig config;

	try {
		config = new SnapdConfig(configFile);
	} catch (SnapdConfigException e) {
		e.print();
		return EXIT_FAILURE;
	}

	auto snapd = new Snapd(config);

	try {
		argumets
			.on("init", (init) {
				snapd.initialize();
			})
			.on("status", (status) {
				snapd.status();
			})
			.on("create", (create) {
				snapd.create();
			});
	} catch (SnapdException e) {
		e.print();
		return EXIT_FAILURE;
	}

	return EXIT_SUCCESS;
}
